Include "DevilShadowSystem.bb"
Include "ShadowVolumes.bb"
Include "UserInterface.bb"


;+++++++++++++++++++++++++++++++++++++++
;Developed by XoreX                    +
;For Boolean.Name                      +
;10.10.2013                            +
;                                      +
;"Devil Shadow System" test, T-34.     +
;+++++++++++++++++++++++++++++++++++++++


;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
Global mesh

AppTitle "Graphics test v 0.1","1"

Function LoadSkyBox()
 mesh=CreateMesh();skybox
 ;front face
 b=LoadBrush("sky1.png",49 )
 s=CreateSurface( mesh,b )
 AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
 AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;right face	
 b=LoadBrush("sky1.png",49 )
 s=CreateSurface( mesh,b )
 AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
 AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;back face
 b=LoadBrush("sky1.png",49 )
 s=CreateSurface( mesh,b )
 AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
 AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;Left face
 b=LoadBrush("sky1.png",49 )
 s=CreateSurface( mesh,b )
 AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
 AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;top face
 b=LoadBrush("sky2.png",49 )
 s=CreateSurface( mesh,b )
 AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
 AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ScaleMesh mesh,300,100,300
 FlipMesh mesh
 EntityFX mesh,1
 Return mesh
End Function

Function cameramove()
 mmx# = -MouseXSpeed() / 3.0
 mmy# = MouseYSpeed() / 3.0
 RotateEntity camera, EntityPitch(camera) + mmy, EntityYaw(camera) + mmx, 0
 MoveMouse 400,300
 If KeyDown(17) Then MoveEntity camera,0,0,.1
 If KeyDown(31) Then MoveEntity camera,0,0,-0.1
 If KeyDown(30) Then MoveEntity camera,-.1,0,0
 If KeyDown(32) Then MoveEntity camera,.1,0,0    
End Function

Function updateskybox()
  EntityParent mesh,camera

 If x > 100 Or z > 100 Then PositionEntity camera, x - 1, y, z - 1
 If x < -100 Or z < -100 Then PositionEntity camera, x + 1, y, z + 1
 If y > 60 Then PositionEntity camera, x, y - 1, z
 
 PositionEntity mesh,30,25 ,- 20
 RotateEntity mesh,0,0,0,True 

End Function

;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
Graphics3D 1024,768,0,2
SetBuffer BackBuffer()

AntiAlias True

Collisions 1,2,2,2

light = CreateLight()
 PositionEntity light,400,500,800
 PointEntity Light, CreatePivot()
 AmbientLight 200,200,200
 SetShadowLight(light,True)
Global camera = CreateCamera()
 CameraFogMode camera,1
 CameraFogRange camera,1,200
 CameraFogColor camera,150,150,255
 CameraRange camera,.0001,800
 PositionEntity camera,10,5,0
 EntityType camera,1
 InitShadows(camera)
plane = CreatePlane();Floor
 SetShadowMesh(plane,False)
 planetex = LoadTexture("grass.jpg")
 EntityTexture plane,planetex 
 EntityType plane,2

tank= LoadMesh("1.3ds")
 ScaleMesh tank,2,2,2
 EntityType tank,2
 SetShadowMesh(tank)

LoadSkyBox()
SetShadowMesh(mesh,False) 

While Not KeyHit(1)
 cameramove()
 updateskybox()

 
 Render(1) 
 Flip 

 Delay(3)
Wend

End